# Loonies 8192 r50 for DOS and SDL platforms
# Copyright (C) 2018-2020 Thomas Perl <m@thp.io>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

# Combine the source files and resolve any include directives
# in such a way that we end up with a single .cpp file that
# can easily be compiled with Borland C++ for DOS.

lines = []

for filename in ('src/loonies.cpp', 'src/platform/dos/loonport.cpp'):
    lines.extend(open(filename).readlines())

included_files = set()

def lines_to_file(fp, lines):
    for line in lines:
        line = line.rstrip('\r\n')
        if line.startswith('#include "'):
            filename = line[10:-1]
            if filename not in included_files:
                included_files.add(filename)
                lines_to_file(fp, open('src/' + filename).readlines())
            continue
        print(line, file=fp, end='\r\n')

with open('LOONIES8.CPP', 'w') as fp:
    lines_to_file(fp, lines)
